Index: trunk/kernel/drivers/soclib/soclib_mmc.h
===================================================================
--- trunk/kernel/drivers/soclib/soclib_mmc.h	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_mmc.h	(revision 1)
@@ -0,0 +1,185 @@
+/*
+ * soclib_mmc.h - SOCLIB_MMC (TSAR L2 cache) driver definition.
+ *
+ * Author    Alain Greiner
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SOCLIB_MMC_H_
+#define _SOCLIB_MMC_H_
+
+#include <device.h>
+#include <dev_mmc.h>
+#include <hal_types.h>
+
+/********************************************************************************************
+ * This driver supports the SocLib VciMemCache component, that is the L2 cache used
+ * by the TSAR architure.
+ *******************************************************************************************/
+
+/********************************************************************************************
+ *       SOCLIB_MMC registers offset 
+ *  - the register index is coded on 7 address bits : A[8:2]
+ *  - the functionnality is coded on 2 address bits : A[10:9]
+ *******************************************************************************************/
+
+enum SoclibMemCacheFunc
+{
+    SOCLIB_MMC_CC_FUNC    = 0,
+    SOCLIB_MMC_INSTR_FUNC = 1,
+    SOCLIB_MMC_ERROR_FUNC = 2,
+
+    SOCLIB_MMC_FUNC_SPAN  = 0x200
+};
+
+enum SoclibMemCacheCCRegs
+{
+    SOCLIB_MMC_ADDR_LO    = 0,
+    SOCLIB_MMC_ADDR_HI    = 1,
+    SOCLIB_MMC_BUF_LENGTH = 2,
+    SOCLIB_MMC_CMD_TYPE   = 3,
+};
+
+enum SoclibMemCacheConfigCmd
+{
+    SOCLIB_MMC_CC_NOP     = 0,
+    SOCLIB_MMC_CC_INVAL   = 1,
+    SOCLIB_MMC_CC_SYNC    = 2,
+};
+
+enum SoclibMemCacheInstrRegs 
+{
+
+    // NUMBER OF LOCAL TRANSACTIONS ON DIRECT NETWORK 
+
+    SOCLIB_MMC_LOCAL_READ_LO     = 0x00,
+    SOCLIB_MMC_LOCAL_READ_HI     = 0x01,
+    SOCLIB_MMC_LOCAL_WRITE_LO    = 0x02,
+    SOCLIB_MMC_LOCAL_WRITE_HI    = 0x03,
+    SOCLIB_MMC_LOCAL_LL_LO       = 0x04,
+    SOCLIB_MMC_LOCAL_LL_HI       = 0x05,
+    SOCLIB_MMC_LOCAL_SC_LO       = 0x06,
+    SOCLIB_MMC_LOCAL_SC_HI       = 0x07,
+    SOCLIB_MMC_LOCAL_CAS_LO      = 0x08,
+    SOCLIB_MMC_LOCAL_CAS_HI      = 0x09,
+
+    // NUMBER OF REMOTE TRANSACTIONS ON DIRECT NETWORK 
+
+    SOCLIB_MMC_REMOTE_READ_LO    = 0x10,
+    SOCLIB_MMC_REMOTE_READ_HI    = 0x11,
+    SOCLIB_MMC_REMOTE_WRITE_LO   = 0x12,
+    SOCLIB_MMC_REMOTE_WRITE_HI   = 0x13,
+    SOCLIB_MMC_REMOTE_LL_LO      = 0x14,
+    SOCLIB_MMC_REMOTE_LL_HI      = 0x15,
+    SOCLIB_MMC_REMOTE_SC_LO      = 0x16,
+    SOCLIB_MMC_REMOTE_SC_HI      = 0x17,
+    SOCLIB_MMC_REMOTE_CAS_LO     = 0x18,
+    SOCLIB_MMC_REMOTE_CAS_HI     = 0x19,
+
+    // COST OF TRANSACTIONS ON DIRECT NETWORK
+
+    SOCLIB_MMC_COST_READ_LO      = 0x20,
+    SOCLIB_MMC_COST_READ_HI      = 0x21,
+    SOCLIB_MMC_COST_WRITE_LO     = 0x22,
+    SOCLIB_MMC_COST_WRITE_HI     = 0x23,
+    SOCLIB_MMC_COST_LL_LO        = 0x24,
+    SOCLIB_MMC_COST_LL_HI        = 0x25,
+    SOCLIB_MMC_COST_SC_LO        = 0x26,
+    SOCLIB_MMC_COST_SC_HI        = 0x27,
+    SOCLIB_MMC_COST_CAS_LO       = 0x28,
+    SOCLIB_MMC_COST_CAS_HI       = 0x29,
+
+    // NUMBER OF LOCAL TRANSACTIONS ON CC NETWORK
+
+    SOCLIB_MMC_LOCAL_MUPDATE_LO  = 0x40,
+    SOCLIB_MMC_LOCAL_MUPDATE_HI  = 0x41,
+    SOCLIB_MMC_LOCAL_MINVAL_LO   = 0x42,
+    SOCLIB_MMC_LOCAL_MINVAL_HI   = 0x43,
+    SOCLIB_MMC_LOCAL_CLEANUP_LO  = 0x44,
+    SOCLIB_MMC_LOCAL_CLEANUP_HI  = 0x45,
+
+    // NUMBER OF REMOTE TRANSACTIONS ON CC NETWORK
+
+    SOCLIB_MMC_REMOTE_MUPDATE_LO = 0x50,
+    SOCLIB_MMC_REMOTE_MUPDATE_HI = 0x51,
+    SOCLIB_MMC_REMOTE_MINVAL_LO  = 0x52,
+    SOCLIB_MMC_REMOTE_MINVAL_HI  = 0x53,
+    SOCLIB_MMC_REMOTE_CLEANUP_LO = 0x54,
+    SOCLIB_MMC_REMOTE_CLEANUP_HI = 0x55,
+
+    // COST OF TRANSACTIONS ON CC NETWORK
+
+    SOCLIB_MMC_COST_MUPDATE_LO   = 0x60,
+    SOCLIB_MMC_COST_MUPDATE_HI   = 0x61,
+    SOCLIB_MMC_COST_MINVAL_LO    = 0x62,
+    SOCLIB_MMC_COST_MINVAL_HI    = 0x63,
+    SOCLIB_MMC_COST_CLEANUP_LO   = 0x64,
+    SOCLIB_MMC_COST_CLEANUP_HI   = 0x65,
+
+    // TOTAL
+
+    SOCLIB_MMC_TOTAL_MUPDATE_LO  = 0x68,
+    SOCLIB_MMC_TOTAL_MUPDATE_HI  = 0x69,
+    SOCLIB_MMC_TOTAL_MINVAL_LO   = 0x6A,
+    SOCLIB_MMC_TOTAL_MINVAL_HI   = 0x6B,
+    SOCLIB_MMC_TOTAL_BINVAL_LO   = 0x6C,
+    SOCLIB_MMC_TOTAL_BINVAL_HI   = 0x6D,
+};
+
+enum SoclibMemCacheRerrorRegs
+{
+    SOCLIB_MMC_ERROR_ADDR_LO     = 0,
+    SOCLIB_MMC_ERROR_ADDR_HI     = 1,
+    SOCLIB_MMC_ERROR_SRCID       = 2, 
+    SOCLIB_MMC_ERROR_IRQ_RESET   = 3,
+    SOCLIB_MMC_ERROR_IRQ_ENABLE  = 4,
+};
+
+
+#define MMC_REG(func,index) ((func<<7)|index) 
+
+
+/********************************************************************************************
+ * This function initializes the SOCLIB_MMC peripheral hardware registers related
+ * to error signaling to enable the MMC peripheral IRQ.
+ ********************************************************************************************
+ * @ dev_xp     : extended pointer on the generic MMC device descriptor.
+ *******************************************************************************************/
+extern void soclib_mmc_init( xptr_t dev_xp );
+
+/********************************************************************************************
+ * This blocking function can be called by any thread running in any cluster.
+ * It executes the command registered in the calling thread descriptor.
+ * The MMC device spinlock must have been taken by the calling thead.
+ ********************************************************************************************
+ * @ thread_xp  : extended pointer on the client thread.
+ *******************************************************************************************/
+extern void soclib_mmc_command( xptr_t thread_xp );
+
+/********************************************************************************************
+ * This Interrupt Service Routine is executed when the MMC IRQ signals a faulty address.
+ * The ISR should access the vci_mem_cache component to get the faulty physical address 
+ * and the associated SRCID, and acknowledges the IRQ.
+ ********************************************************************************************
+ * @ dev     : local pointer on the generic MMC device descriptor.
+ *******************************************************************************************/
+extern void soclib_mmc_isr( device_t * dev );
+
+
+#endif // SOCLIB_MMC_H_
Index: trunk/kernel/drivers/soclib/soclib_nic.c
===================================================================
--- trunk/kernel/drivers/soclib/soclib_nic.c	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_nic.c	(revision 1)
@@ -0,0 +1,334 @@
+/*
+ * soclib_nic.c - SOCLIB_NIC (Network Interface Controler) driver implementation.
+ *
+ * Author     Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH.is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH.is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <hal_types.h>
+#include <hal_remote.h>
+#include <hal_special.h>
+#include <device.h>
+#include <dev_nic.h>
+#include <spinlock.h>
+#include <kmem.h>
+#include <printk.h>
+#include <memcpy.h>
+#include <thread.h>
+#include <soclib_nic.h>
+
+
+/////////////////////////////////////
+void soclib_nic_init( xptr_t dev_xp )
+{
+    uint32_t    i;
+    kmem_req_t  req;
+    
+    // get NIC device descriptor cluster and local pointer
+    cxy_t      dev_cxy  = GET_CXY( dev_xp );
+    device_t * dev_ptr  = (device_t *)GET_PTR( dev_xp );
+  
+    // get hardware device base address
+	xptr_t     base = hal_remote_lwd( XPTR( dev_cxy , &dev_ptr->base ) );
+
+    // get hardware device cluster and local pointer
+    cxy_t      nic_cxy  = GET_CXY( base );
+    uint32_t * nic_ptr  = (uint32_t *)GET_PTR( base );
+
+    // initialize Soclib NIC global registers 
+    hal_remote_sw( XPTR( nic_cxy , &nic_ptr + NIC_G_BC_ENABLE ) , 0 );
+    hal_remote_sw( XPTR( nic_cxy , &nic_ptr + NIC_G_RUN       ) , 0 );
+
+    // allocate memory for chbuf descriptor (one page)
+    if( sizeof(nic_chbuf_t) > CONFIG_PPM_PAGE_SIZE )
+    {
+        printk("\n[PANIC] in %s : chbuf descriptor exceeds one page\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    req.type   = KMEM_PAGE;
+    req.size   = 0;
+    req.flags  = AF_KERNEL;
+
+    nic_chbuf_t * chbuf = (nic_chbuf_t *)kmem_alloc( &req );
+
+    if( chbuf == NULL )
+    {
+        hal_core_sleep("%s : no more memory for chbuf desccriptor\n", __FUNCTION__ );
+    }
+
+    // initialise chbuf state
+    chbuf->cont_id  = 0;
+    chbuf->pkt_id   = 0;
+    chbuf->word_id  = 34;
+    
+    // allocate containers (one page per container)
+    // and complete chbuf descriptor initialization
+    if( CONFIG_PPM_PAGE_SIZE != 4096 )
+    {
+        hal_core_sleep("%s : chbuf container must be 4 Kbytes\n", __FUNCTION__ );
+    }
+
+    for( i = 0 ; i < CONFIG_NIC_CHBUF_DEPTH ; i++ )
+    {
+        uint32_t * container = (uint32_t *)kmem_alloc( &req );   
+
+        if( container == NULL )
+        {
+            hal_core_sleep("%s : no more memory for container\n", __FUNCTION__ );
+        }
+        
+        chbuf->cont[i] = container;
+        chbuf->full[i] = (paddr_t)XPTR( local_cxy , container );
+    }
+
+} // end soclib_nic_init()
+
+
+//////////////////////////////////////////////////////////////////
+void __attribute__ ((noinline)) soclib_nic_cmd( xptr_t thread_xp )
+{
+    uint32_t       cmd;          // command type    
+    char         * buffer;       // pointer on command buffer   
+    uint32_t       length;       // Ethernet packet length
+    xptr_t         dev_xp;       // extended pointer on NIC device
+    nic_chbuf_t  * chbuf;        // pointer on chbuf descriptor
+    uint32_t       cont_id;      // index of current container in chbuf
+    uint32_t       pkt_id;       // index of current packet in container
+    uint32_t       word_id;      // index of first word of current packet in container
+    uint32_t     * container;    // pointer on container (array of uint32_t)
+    uint16_t     * header;       // pointer on container header (array of uint16_t)
+    uint32_t       npackets;     // number of packets in current container
+
+    // get local pointer for client thread
+    thread_t * thread_ptr = (thread_t *)GET_PTR( thread_xp );
+
+    // get command arguments
+    cmd    = thread_ptr->dev.nic.cmd;
+    buffer = thread_ptr->dev.nic.buffer;
+    length = thread_ptr->dev.nic.length;
+    dev_xp = thread_ptr->dev.nic.dev_xp;
+
+    // get local pointer for device
+    device_t * dev_ptr = (device_t *)GET_PTR( dev_xp );
+
+    // get chbuf descriptor pointer
+    chbuf = (nic_chbuf_t *)dev_ptr->ext.nic.queue;
+
+    // analyse command type
+    switch( cmd )
+    {
+        /////////////////////////////////////////////////////////////////////////////
+        case NIC_CMD_READ:   // transfer one packet from RX queue to command buffer
+        {
+            // get current container index
+            cont_id = chbuf->cont_id;
+            
+            if( chbuf->full[cont_id] == 0 )  // container empty
+            {
+                printk("PANIC in %s : read an empty container\n", __FUNCTION__ );
+                hal_core_sleep();
+            }
+
+            // get pointer on container and header 
+            container = chbuf->cont[cont_id];
+            header    = (uint16_t *)container;
+
+            // get  expected packet index and first word index in container
+            pkt_id  = chbuf->pkt_id;
+            word_id = chbuf->word_id;
+
+            // get packet length and number of packets from container header
+            length    = header[pkt_id + 2];
+            npackets  = header[0];
+
+            if( pkt_id >= npackets )  // packet index too large
+            {
+                printk("PANIC in %s : read a non readable container\n", __FUNCTION__ );
+                hal_core_sleep();
+            }
+
+            // move the packet from container to buffer
+            memcpy( buffer , container + word_id , length );
+
+            // update current packet index and first word index
+            chbuf->pkt_id  = pkt_id + 1;
+            if( length & 0x3 ) chbuf->word_id = word_id + (length>>2) + 1;
+            else               chbuf->word_id = word_id + (length>>2);
+        }
+        break;    // end READ
+            
+        //////////////////////////////////////////////////////////////////////////
+        case NIC_CMD_WRITE:  // move one packet from command buffer to TX queue
+        {
+            // get current TX container indexes
+            cont_id = chbuf->cont_id;
+            pkt_id  = chbuf->pkt_id;
+            word_id = chbuf->word_id;
+
+            if( chbuf->full[cont_id] != 0 )  // container full
+            {
+                printk("PANIC in %s : write to a full container\n", __FUNCTION__ );
+                hal_core_sleep();
+            }
+
+            // get pointer on container and header 
+            container = chbuf->cont[cont_id];
+            header    = (uint16_t *)container;
+
+            if( length > ((1024 - word_id)<<2) )  // packet length too large
+            {
+                printk("PANIC in %s : write to a non writable container\n", __FUNCTION__ );
+                hal_core_sleep();
+            }
+
+            // update packet length in container header
+            header[pkt_id + 2] = (uint16_t)length;
+
+            // move the packet from buffer to container
+            memcpy( container + word_id , buffer , length );
+
+            // update current packet index and first word index
+            chbuf->pkt_id  = pkt_id + 1;
+            if( length & 0x3 ) chbuf->word_id = word_id + (length>>2) + 1;
+            else               chbuf->word_id = word_id + (length>>2);
+        }
+        break;  // end WRITE
+
+        ////////////////////////////////////////////////////////////////////////////
+        case NIC_CMD_WRITABLE:  // analyse chbuf status / update status if required
+        {
+            // get current container state 
+            cont_id = chbuf->cont_id;
+            word_id = chbuf->word_id;
+
+            // compute current container writable
+            bool_t ok = ( chbuf->full[cont_id] == 0 ) &&
+                        ( length <= ((1024 - word_id)<<2) );
+
+            if( ok )                // current container writable
+            {
+                // return chbuf writable
+                thread_ptr->dev.nic.status = true;
+            }
+            else                    // current container not writable
+            {
+                // release current container
+                chbuf->full[cont_id] = 1;
+
+                // check next container 
+                cont_id = (cont_id + 1) % CONFIG_NIC_CHBUF_DEPTH;
+
+                if( chbuf->full[cont_id] == 0 ) // next container empty
+                {
+                    // update chbuf status
+                    chbuf->word_id = 34;
+                    chbuf->cont_id = cont_id;
+                    chbuf->pkt_id  = 0;
+                     
+                    // return chbuf writable
+                    thread_ptr->dev.nic.status = true;
+                }
+                else                            // next container full     
+                {
+                    // return chbuf non writable
+                    thread_ptr->dev.nic.status = false;
+                }
+            }
+        }
+        break;  // end WRITABLE
+
+        /////////////////////////////////////////////////////////////////////////////
+        case NIC_CMD_READABLE:  // analyse chbuf status / update status if required
+        {
+            // get current container state
+            cont_id  = chbuf->cont_id;
+            pkt_id   = chbuf->pkt_id;
+            npackets = chbuf->cont[cont_id][0] & 0x0000FFFF; 
+            
+            // compute current container readable
+            bool_t ok = ( chbuf->full[cont_id] == 1 ) &&
+                        ( pkt_id < npackets );
+
+            if( ok )                    // current container readable
+            {
+                // return chbuf readable     
+                thread_ptr->dev.nic.status = true;
+            }
+            else                        // current container non readable
+            {
+                // release current container
+                chbuf->full[cont_id] = 0;
+
+                // check next container
+                cont_id = (cont_id + 1) % CONFIG_NIC_CHBUF_DEPTH;
+
+                if( chbuf->full[cont_id] == 1 ) // next container full 
+                {
+                    // update chbuf status
+                    chbuf->word_id = 34;
+                    chbuf->cont_id = cont_id;
+                    chbuf->pkt_id  = 0;
+                     
+                    // return chbuf readable
+                    thread_ptr->dev.nic.status = true;
+                }
+                else                            // next container empty    
+                {
+                    // return chbuf non readable
+                    thread_ptr->dev.nic.status = false;
+                }
+            }
+   
+        }
+        break;  // end READABLE
+    } 
+} // end soclib_nic_cmd()
+
+
+////////////////////////////////////////////////////////////////
+void __attribute__ ((noinline)) soclib_nic_isr( device_t * dev )
+{
+    // get base, size, channel, is_rx from NIC channel device NIC 
+    xptr_t     base    = dev->base;
+    uint32_t   channel = dev->channel;
+    bool_t     is_rx   = dev->is_rx;
+
+    // get NIC peripheral cluster and local pointer
+    cxy_t      cxy_nic = GET_CXY( base );
+    uint32_t * ptr_nic = (uint32_t *)GET_PTR( base );
+
+    // compute local pointer on status register 
+    uint32_t * offset;
+    if( is_rx ) offset = ptr_nic + (NIC_CHANNEL_SPAN * (channel + 1)) + NIC_RX_STATUS;
+    else        offset = ptr_nic + (NIC_CHANNEL_SPAN * (channel + 1)) + NIC_TX_STATUS;
+
+    // read NIC channel status and acknowledge IRQ
+    uint32_t status = hal_remote_lw( XPTR( cxy_nic , offset ) );
+
+    if( status != 0 ) hal_core_sleep("%s : illegal address\n", __FUNCTION__ );
+    
+    // unblock server thread 
+    thread_t * server = dev->server;
+    thread_unblock( XPTR( local_cxy , server ) , THREAD_BLOCKED_IO );
+
+} // end soclib_nic_isr()
+
+
+
Index: trunk/kernel/drivers/soclib/soclib_nic.h
===================================================================
--- trunk/kernel/drivers/soclib/soclib_nic.h	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_nic.h	(revision 1)
@@ -0,0 +1,203 @@
+/*
+ * soclib_nic.h - SOCLIB_NIC (Network Interface Controler) driver definition.
+ *
+ * Author    Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SOCLIB_NIC_H_
+#define _SOCLIB_NIC_H_
+
+#include <device.h>
+#include <hal_types.h>
+
+/********************************************************************************************
+ * This driver supports the Soclib VciMasterNic component, that is a GMII compliant
+ * multi-channels Gigabit Ethernet controler. 
+ *
+ * The VciMasterNic component supports up to 4 channels, indexed by the source IP address
+ * for the RX packets, and by the destination IP address for the TX packets. 
+ * 
+ * The Ethernet packet length can have any value, between 64 to 1538 bytes.
+ * The data transfer unit between software and the NIC is a 4 Kbytes "container",
+ * containing an integer number of variable size packets.
+ *
+ * The max number of packets in a container is 66 packets.
+ * The first 34 words of a container are the container header :
+ *
+ *     word0  	| 	NB_WORDS	|	NB_PACKETS	|
+ *     word1	|	PLEN[0]		|	PLEN[1]		|
+ *      ...	    |	.......		|	........	|
+ *     word33	|	PLEN[64]	|	PLEN[65]	|
+ *
+ *  - NB_PACKETS is the actual number of packets in the container.
+ *	- NB_WORDS   is the number of useful words in the container.
+ *	- PLEN[i]    is the number of bytes for the packet[i].
+ *
+ * Packets are stored in the (1024 - 34) following words, and the packets are word-aligned.
+ *
+ * The TX and RX queues are implemented as chained buffers, where each buffer is a 4 Kbytes
+ * container. Each container is protected by a SET/RESET synchronisation variable. 
+ * The structure implementing the chbuf descriptor is described below.
+ *
+ * To access both the container status, and the data contained in the container, the NIC
+ * uses two physical addresses, that are packed in a 64 bits "container descriptor". 
+ * - desc[25:0]  contain bits[31:6] of the status physical address.
+ * - desc[51:26] contain bits[31:6] of the buffer physical address.
+ * - desc[63:52] contain the common 12 physical address extension bits.
+ *******************************************************************************************/
+
+/********************************************************************************************
+ *       Addressable registers offsets 
+ *******************************************************************************************/
+
+enum SoclibMasterNicGlobalRegisters 
+{
+    NIC_G_RUN                        = 0,   /*! read_write : NIC component activated       */
+    NIC_G_NB_CHANNELS                = 1,   /*! read_only  : number of channels            */
+    NIC_G_BC_ENABLE                  = 2,   /*! read_write : broadcast enabled if non zero */ 
+    NIC_G_PERIOD                     = 3,   /*! read-write : container status poll period  */
+    NIC_G_MAC_4                      = 4,   /*! read-write : mac address 32 LSB bits       */
+    NIC_G_MAC_2                      = 5,   /*! read-write : mac address 16 MSB bits       */
+
+    NIC_G_NPKT_RX_G2S_RECEIVED       = 10,  /*! number of packets received                 */
+    NIC_G_NPKT_RX_G2S_DISCARDED      = 11,  /*! number of RX packets discarded by RX_G2S   */
+    NIC_G_NPKT_RX_DES_SUCCESS        = 12,  /*! number of RX packets transmited by RX_DES  */
+    NIC_G_NPKT_RX_DES_TOO_SMALL      = 13,  /*! number of discarded too small RX packets   */
+    NIC_G_NPKT_RX_DES_TOO_BIG        = 14,  /*! number of discarded too big RX packets     */
+    NIC_G_NPKT_RX_DES_MFIFO_FULL     = 15,  /*! number of discarded RX packets fifo full   */
+    NIC_G_NPKT_RX_DES_CRC_FAIL       = 16,  /*! number of discarded RX packets CRC32       */
+    NIC_G_NPKT_RX_DISPATCH_RECEIVED  = 17,  /*! number of packets received by RX_DISPATCH  */
+    NIC_G_NPKT_RX_DISPATCH_BROADCAST = 18,  /*! number of broadcast RX packets received    */
+    NIC_G_NPKT_RX_DISPATCH_DST_FAIL  = 19,  /*! number of discarded RX packets for DST MAC */
+    NIC_G_NPKT_RX_DISPATCH_CH_FULL   = 20,  /*! number of discarded RX packets cont full   */
+
+    NIC_G_NPKT_TX_DISPATCH_RECEIVED  = 41,  /*! number of packets received by TX_DISPATCH  */
+    NIC_G_NPKT_TX_DISPATCH_TOO_SMALL = 42,  /*! number of discarded too small TX packets   */
+    NIC_G_NPKT_TX_DISPATCH_TOO_BIG   = 43,  /*! number of discarded too big TX packets     */
+    NIC_G_NPKT_TX_DISPATCH_SRC_FAIL  = 44,  /*! number of discarded TX packets for SRC MAC */
+    NIC_G_NPKT_TX_DISPATCH_BROADCAST = 45,  /*! number of broadcast TX packets received    */
+    NIC_G_NPKT_TX_DISPATCH_TRANSMIT  = 46,  /*! number of transmit TX packets              */
+
+    NIC_GLOBAL_SPAN                  = 64   /*! 256 bytes for global registers             */
+};
+
+enum SoclibMasterNicChannelRegisters 
+{
+    NIC_RX_STATUS             = 0,    /*! read-only  : RX channel status                   */
+    NIC_RX_CHBUF_DESC_L0      = 1,    /*! read-write : RX chbuf descriptor 32 LSB bits     */ 
+    NIC_RX_CHBUF_DESC_HI      = 2,    /*! read-write : RX chbuf descriptor 32 MSB bits     */ 
+    NIC_RX_CHBUF_NBUFS        = 3,    /*! read-write : RX chbuf depth (number of buffers)  */
+    
+    NIC_TX_STATUS             = 8,    /*! read-only  : TX channel status                   */
+    NIC_TX_CHBUF_DESC_L0      = 9,    /*! read-write : TX chbuf descriptor 32 LSB bits     */ 
+    NIC_TX_CHBUF_DESC_HI      = 10,   /*! read-write : TX chbuf descriptor 32 MSB bits     */ 
+    NIC_TX_CHBUF_NBUFS        = 11,   /*! read-write : TX chbuf depth (number of buffers)  */
+
+    NIC_CHANNEL_SPAN          = 16    /*! 64 bytes per channel                             */
+};
+    
+
+
+/********************************************************************************************
+ * This structure defines the chained buffer descriptor, used to implement both
+ * the RX and TX packets queues. Each buffer in a chbuf is a 4 Kbytes container
+ * containing a variable number of packets. All containers are allocated in 
+ * the same cluster as the associated NIC device descriptor. The chbuf descriptor contains:
+ * - an array of container pointers cont[], used by the kernet threads to access the
+ *   packets contained in the containers.
+ * - an array of set/reset Boolean full[] used by both the software threads and 
+ *   by the hardware FSMs for lock-less synchronisation. 
+ * - an array of containers descriptors containing the physical addresses of the
+ *   "full[i]" and "cont[i]" variables, used by the DMA FSMs. 
+ * Moreover, It contains three pointers (cont_id, pkt_id, and word_id) that are private
+ * variables used by the software thread to scan the chbuf. 
+ *******************************************************************************************/
+
+typedef struct nic_chbuf_s
+{
+    uint32_t * cont[CONFIG_NIC_CHBUF_DEPTH]; /*! container virtual base address            */
+    uint32_t   full[CONFIG_NIC_CHBUF_DEPTH]; /*! Boolean : container full if non zero      */
+    uint64_t   desc[CONFIG_NIC_CHBUF_DEPTH]; /*! container & status physical addresses     */
+    uint32_t   cont_id;                      /*! current container index                   */
+    uint32_t   pkt_id;                       /*! current packet index in container         */
+    uint32_t   word_id;                      /*! first word of current packet              */
+}
+nic_chbuf_t;
+
+/********************************************************************************************
+ *        SOCLIB_NIC driver access functions 
+ *******************************************************************************************/
+
+/********************************************************************************************
+ * This function initializes the SOCLIB_NIC hardware registers, allocates memory for
+ * the RX and TX containers, allocates and initializes the RX and TX chbuf descriptors.
+ * It allocates one WTI mailbox for the IRQ signaling availability of an RX full container,
+ * or a TX empty container, and route the WTI IRQ to the core running the server thread.
+ ********************************************************************************************
+ * @ dev_xp  : extended pointer on the generic NIC device descriptor.
+ *******************************************************************************************/
+extern void soclib_nic_init( xptr_t dev_xp );
+
+/********************************************************************************************
+ * This function implement the READ / WRITE / READABLE / WRITABLE commands for TX/RX queues.
+ * These command don't access the NIC peripheral but only the TX and TX chbufs.
+ * It must be executed by a dedicated kernel thread running in the cluster containing
+ * the CHBUF implementing the TX/RX queues.
+ * It implements also the SET_MAC, SET_BC, SET_RUN configuration commands, that directly
+ * access the NIC peripheral registers.
+ * - READABLE 
+ *   Returns in the command "status" a non zero value if a packet is available in RX queue.
+ *   Update the RX queue read pointer if required.
+ * - READ 
+ *   Move a packet from the RX queue to the command "buffer", and returns the packet
+ *   "length" in the command. The READABLE command must be called before the READ command.
+ * - WRITABLE 
+ *   Returns in the command "status" a non zero value if a packet with a given "length"
+ *   can be written in the TX queue. Update the RX queue read pointer if required.
+ * - WRITE
+ *   Move a packet of a given "length" from the command "buffer" to the TX queue.
+ *   The WRITABLE command must be called before the WRITE command.
+ * - SET_MAC 
+ *   Set the values defined in the "length" and "status" command arguments,
+ *   into the NIC_C_MAC4 and NIG_G_MAC2  registers.
+ * - SET_BC
+ *   Enable/disable broadcast packets, as defined in the "status" command argument,
+ *   into the NIC_G_BC_ENABLE register.
+ * - SET_RUN
+ *   Enable/disable NIC, as defined in the "status" command argument, 
+ *   into the NIC_G_RUN register.
+ * @ dev_xp  : extended pointer on the generic NIC device descriptor.
+ ********************************************************************************************
+ $ @ thread_xp : extended pointer on client thread (containing the command arguments).
+ *******************************************************************************************/
+extern void soclib_nic_cmd( xptr_t thread_xp );
+
+/********************************************************************************************
+ * This ISR acknowledge the NIC_RX or NIC_TX channel ISR signaling that a new container
+ * has beeen moved, and reactivate the corresponding server thread.
+ * In case of address error reported by the NIC controler in accessing the kernel chbuf,
+ * it goes to kernel panic.
+ ********************************************************************************************
+ * @ dev     : local pointer on the generic IOC device descriptor.
+ *******************************************************************************************/
+extern void soclib_nic_isr( device_t * dev );
+
+
+#endif /* _BLOCK_H_ */
